def ky_shell_bottom

	model = Sketchup.active_model
	ent = model.active_entities
	sel = model.selection
	all = ent.to_a
	faces=[]; d_faces=[]; r_faces=[]; edges=[]; d_edges_temp=[]; d_edges=[]; r_edges=[]; fix_edges=[]
	all.each {|e| faces<<e if e.class==Sketchup::Face; edges<<e if e.class==Sketchup::Edge}
	faces.each {|e| d_faces<<e if (e.normal.z >= 0) or (e.normal.z.abs < 1.0e-10)}
	r_faces = faces - d_faces
		Sketchup.active_model.start_operation 'shell bottom'
	d_faces.each {|e| e.erase!}
	edges.each {|e| d_edges_temp<<e if e.faces.length == 0}
	r_edges = edges - d_edges_temp
	r_vert = []
	r_faces.each do |e| 
		loops = e.loops
		loops.each {|f| r_vert<<f.vertices}
	end	
	r_vert.flatten!.uniq!
	d_edges_temp.each {|e| if !(r_vert.include?(e.vertices[0])) or !(r_vert.include?(e.vertices[1])) then d_edges<<e else fix_edges<<e end}
	d_edges.each {|e| e.erase!}
	fix_edges.each {|e| e.find_faces}
	
	### Uncomment the following to get the outer perimeter ###
	# new_edges = []; dnew_edges =[]
	# all = ent.to_a
	# all.each {|e| new_edges<<e if e.class==Sketchup::Edge}
	# new_edges.each {|e| dnew_edges<<e if e.faces.length > 1}
	# dnew_edges.each {|e| e.erase!}
	# ent.each {|e| e.erase! if e.class==Sketchup::Face}
	
		Sketchup.active_model.commit_operation
	
end	